/* ѴץऽΣ
** ʣɣӤ饷եȣʣɣӤؤѴ
** Usage: jtos FILENAME        */

#include <stdio.h>

#define ASCII 0
#define KANJI 1

void error(int i) {
	fprintf(stderr, "Error Code = %d\n", i);
	fprintf(stderr, "Usage: jtos [input filename [output filename]]\n");
	exit(i);
}

void main(argc, argv) int argc; char *argv[]; {

	FILE *in, *out;
	char status = ASCII;
	int i, j, k;

	fprintf(stderr, "KANJI CONVERSION JIS to Shift-JIS Ver. 2.0\n");
	fprintf(stderr, "Usage: %s [input [output]]\n", argv[0]);
	switch(argc) {
		case 1:
			in = stdin;
			out = stdout;
			break;
		case 2:
			out = stdout;
			if((in = fopen(argv[1], "rb")) == NULL) error(1);
			break;
		case 3:
			if((in = fopen(argv[1], "rb")) == NULL) error(2);
			if((out = fopen(argv[2], "wb")) == NULL) error(3);
			break;
		default:
			error(4);
			break;
	}
	while((i = fgetc(in)) != EOF) {
		if(i == 0x1b) {
			j = fgetc(in);
			k = fgetc(in);
			switch(j) {
				case 0x24:
					status = KANJI;
					break;
				case 0x28:
					status = ASCII;
					break;
				defaut:
					fputc(i, out);
					fputc(j, out);
					fputc(k, out);
					break;
			}
		} else {
			if(status == ASCII) {
				fputc(i, out);
			} else {
				j = fgetc(in);
				if(i & 1) {
					j += 0x1f;
				} else {
					j += 0x7d;
				}
				i = (i - 0x21 >> 1) + 0x81;
				if(j >= 0x7f) {
					j++;
				}
				if(i > 0x9f) {
					i += 0x40;
				}
				fputc(i, out);
				fputc(j, out);
			}
		}
	}
	fclose(in);
	fclose(out);
	fprintf(stderr, "CONVERSION COMPLETE\n");
}
